=== src/runtime/kwallet-query/CMakeLists.txt ===
project(kwallet-dmenu)

add_subdirectory(src)
